# Class VulkanComputePipelineCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanComputePipelineCreateInfo.Builder

Enclosing class:
  `VulkanComputePipelineCreateInfo`

public static final class VulkanComputePipelineCreateInfo.Builder extends Object
Builds instances of type `VulkanComputePipelineCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanComputePipelineCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanPipelineCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanComputePipelineCreateInfo.Builder`
  `addFlags(VulkanPipelineCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanComputePipelineCreateInfo.Builder`
  `addFlags(VulkanPipelineCreateFlag... elements)`
  Adds elements to `flags` set.
  `VulkanComputePipelineCreateInfo`
  `build()`
  Builds a new `VulkanComputePipelineCreateInfo`.
  `final VulkanComputePipelineCreateInfo.Builder`
  `from(VulkanComputePipelineCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanComputePipelineCreateInfoType` instance.
  `final VulkanComputePipelineCreateInfo.Builder`
  `setBasePipeline(VulkanPipelineType basePipeline)`
  Initializes the optional value `basePipeline` to basePipeline.
  `final VulkanComputePipelineCreateInfo.Builder`
  `setBasePipeline(Optional<? extends VulkanPipelineType> basePipeline)`
  Initializes the optional value `basePipeline` to basePipeline.
  `final VulkanComputePipelineCreateInfo.Builder`
  `setBasePipelineIndex(int basePipelineIndex)`
  Initializes the optional value `basePipelineIndex` to basePipelineIndex.
  `final VulkanComputePipelineCreateInfo.Builder`
  `setBasePipelineIndex(OptionalInt basePipelineIndex)`
  Initializes the optional value `basePipelineIndex` to basePipelineIndex.
  `final VulkanComputePipelineCreateInfo.Builder`
  `setFlags(Iterable<VulkanPipelineCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanComputePipelineCreateInfo.Builder`
  `setLayout(VulkanPipelineLayoutType layout)`
  Initializes the value for the `layout` attribute.
  `final VulkanComputePipelineCreateInfo.Builder`
  `setStage(VulkanPipelineShaderStageCreateInfo stage)`
  Initializes the value for the `stage` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanComputePipelineCreateInfo.Builder from(VulkanComputePipelineCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanComputePipelineCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanComputePipelineCreateInfo.Builder addFlags(VulkanPipelineCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanComputePipelineCreateInfo.Builder addFlags(VulkanPipelineCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanComputePipelineCreateInfo.Builder setFlags(Iterable<VulkanPipelineCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanComputePipelineCreateInfo.Builder addAllFlags(Iterable<VulkanPipelineCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setStage

    public final VulkanComputePipelineCreateInfo.Builder setStage(VulkanPipelineShaderStageCreateInfo stage)
    Initializes the value for the `stage` attribute.
    Parameters:
      `stage` - The value for stage
    Returns:
      `this` builder for use in a chained invocation

  - ### setLayout

    public final VulkanComputePipelineCreateInfo.Builder setLayout(VulkanPipelineLayoutType layout)
    Initializes the value for the `layout` attribute.
    Parameters:
      `layout` - The value for layout
    Returns:
      `this` builder for use in a chained invocation

  - ### setBasePipeline

    public final VulkanComputePipelineCreateInfo.Builder setBasePipeline(VulkanPipelineType basePipeline)
    Initializes the optional value `basePipeline` to basePipeline.
    Parameters:
      `basePipeline` - The value for basePipeline
    Returns:
      `this` builder for chained invocation

  - ### setBasePipeline

    public final VulkanComputePipelineCreateInfo.Builder setBasePipeline(Optional<? extends VulkanPipelineType> basePipeline)
    Initializes the optional value `basePipeline` to basePipeline.
    Parameters:
      `basePipeline` - The value for basePipeline
    Returns:
      `this` builder for use in a chained invocation

  - ### setBasePipelineIndex

    public final VulkanComputePipelineCreateInfo.Builder setBasePipelineIndex(int basePipelineIndex)
    Initializes the optional value `basePipelineIndex` to basePipelineIndex.
    Parameters:
      `basePipelineIndex` - The value for basePipelineIndex
    Returns:
      `this` builder for chained invocation

  - ### setBasePipelineIndex

    public final VulkanComputePipelineCreateInfo.Builder setBasePipelineIndex(OptionalInt basePipelineIndex)
    Initializes the optional value `basePipelineIndex` to basePipelineIndex.
    Parameters:
      `basePipelineIndex` - The value for basePipelineIndex
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanComputePipelineCreateInfo build()
    Builds a new `VulkanComputePipelineCreateInfo`.
    Returns:
      An immutable instance of VulkanComputePipelineCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing